# Search

This core feature is based on [Elasticsearch](https://www.elastic.co/fr/) (ES). Almost all the  information in the portal (including datasets, articles, geographical data) is indexed in ES. This allows lot's of possibilities with the powerful features of this tool.  
Here are the features existing on the portal:

* *research*: thanks to ES great indexation, to go through millions of documents is super fast (millions because we are not only looking inside the metadata, but also inside the data)
* *autocompletion*: using the score based on some criteria, we provides an autocompletion feature that helps to give a context for some research keywords.
* *suggestion*: if a research didn't give good or no results (for example because of a typo), a word with more results will be suggested.

Of course there is a plenty of room for improvements for these features (and for new ones). ES is very powerful but also very complex to master. It's in a constant improvement.

![Search page](../../../assets/search.png)

## Datasets results

As in many search tools the results are displayed in different tabs representing different results categories: `All`, `Data`, `Services` and the `News` (editorial content).
For each tab these results are paginate with 10 entries per page.

It's possible to sort the results by relevance, date and alphabetically.

## Research features

See the [search bar](./header.md#Search-bar) documentation

## Filters

![Filters](../../../assets/filters.png)

On the left side of the screen the user has the possibility to add filters and subfilters (depending the category)
These categories (e.g. producers, licences, formats) are based on the metadata properties. Then each value for these properties are aggregated.
Inside one filter category, the values are sorted by the number of datasets.

### Behavior inside and between filters category

If the user selects multiple values inside one filter category, they will behave as `OR` operators. It means that the datasets matching with one category **or** another one are displayed.
On another hand, if the user selects different filters in different filter categories; they will behave as `AND` operators. For example if we apply the filters `SYTRAL` in Producers and `WMS` in Services, it will display the datasets that are matching with these two conditions.

## Suggestion

![Filters](../../../assets/suggestion.png)

This is a useful feature, especially for typo. If your research doesn't give you any result, Elasticsearch might find for you a word that is close of yours that would give more success in the results.
